/* jshint ignore:start */
var messageSent = false;
function bringFocus() {
    window.focus();
}

function onLoginLoad() {
    document.addEventListener('keydown', bringFocus);
    document.addEventListener('touchend', bringFocus);
    if (!window.parent.showSignup) {
        document.getElementById('signup').style.display = "none" ;
    }
    if (document.login) {
        document.login.action = parent.BASE_URL + '/app/authentication';
        document.getElementById('j_username').value = localStorage.getItem("username") || '';
        if (!window.parent.showFingerprint) {
            document.getElementById('fingerprintLogin').style.display = "none";
        }
    }
}
function goToSignUp() {
    var message = {
        goTo: 'signup'
    };
    postMessage(JSON.stringify(message));
}

function fingerprint() {
    var message = {
        goTo: 'fingerprint',
        presentUser: document.getElementById('j_username').value.trim()
    };
    postMessage(JSON.stringify(message));
}

function onForgotPassword() {
    var message = {
        goTo: 'forgotPassword'
    };
    postMessage(JSON.stringify(message));
}

function updatePersistSession() {
    parent.PERSIST_SESSION = document.getElementById('persist-session').checked;
}

function isPingSuccessful(httpRequest) {
    // IE: sometimes 1223 instead of 204
    var success = (httpRequest.status === 0 ||
        (httpRequest.status >= 200 && httpRequest.status < 300) ||
        httpRequest.status === 304 || httpRequest.status === 1223);
    return success;
}

function onPingFailure(errCode) {
    document.getElementById('Signin').removeAttribute('disabled');
    document.getElementById('Signin').value = "Sign In" ;
    if (!messageSent) {
        postMessage(JSON.stringify({
            error: errCode
        }));
    }
}

function initiatePing() {
    var httpRequest = new XMLHttpRequest(),
        pingUrl = parent.BASE_URL + '/msbapi/public/alive',
        timer = null;
    messageSent = false;
    try {
        httpRequest.open('get', pingUrl, false);
        httpRequest.setRequestHeader("Content-Type", "application/json");
        timer = setTimeout(function () {
            httpRequest.abort();
            document.getElementById('Signin').removeAttribute('disabled');
            document.getElementById('Signin').value = "Sign In" ;
            throw "Time out happened.";
        }, 5000);
        httpRequest.send();
    } catch (e) {
        document.getElementById('Signin').removeAttribute('disabled');
        document.getElementById('Signin').value = "Sign In" ;
        onPingFailure(parent.CONSTANTS.ERROR_CODES.isOffline);
        return false;
    }

    // handle the response
    if (!isPingSuccessful(httpRequest)) {
        clearTimeout(timer);
        onPingFailure(parent.CONSTANTS.ERROR_CODES.serverError);
        return false;
    }

    return true;
}

function rememberUser() {
    document.getElementById('Signin').setAttribute('disabled', true);
    document.getElementById('Signin').value = "Signing In" ;
    postMessage(JSON.stringify({
        currentUser: document.getElementById('j_username').value.trim(),
        password: document.getElementById('j_password').value.trim()
    }));
    localStorage.setItem('lastLoggedInUser', localStorage.getItem("username"));
    localStorage.setItem('username', document.getElementById('j_username').value.trim());
    // Submit form if ping is successfull;
    return initiatePing();
}

function postMessage(message) {
    window.parent.postMessage(message, '*');
}

function getRouteParam(url, param) {
    param = param + '=';

    if (url.indexOf(param) < 0) {
        return '';
    }

    url = url.split(param)[1];

    if (url.indexOf('&') > -1) {
        return url.split('&')[0];
    }
    return url;
}
/* jshint ignore:end */
